PF-build.sh 37 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_27
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Audrino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multilanguage vairants it makes it easier to find missing or unused transltions.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to scrpit commits
  129. #### Start check if OSTYPE is supported
  130. OS_FOUND=$( command -v uname)
  131. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  132. linux*)
  133. TARGET_OS="linux"
  134. ;;
  135. msys*|cygwin*|mingw*)
  136. # or possible 'bash on windows'
  137. TARGET_OS='windows'
  138. ;;
  139. nt|win*)
  140. TARGET_OS='windows'
  141. ;;
  142. *)
  143. TARGET_OS='unknown'
  144. ;;
  145. esac
  146. # Windows
  147. if [ $TARGET_OS == "windows" ]; then
  148. if [ $(uname -m) == "x86_64" ]; then
  149. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  150. Processor="64"
  151. elif [ $(uname -m) == "i386" ]; then
  152. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  153. Processor="32"
  154. else
  155. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  156. echo "Please refer to the notes of build.sh$(tput sgr0)"
  157. exit 1
  158. fi
  159. # Linux
  160. elif [ $TARGET_OS == "linux" ]; then
  161. if [ $(uname -m) == "x86_64" ]; then
  162. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  163. Processor="64"
  164. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  165. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  166. Processor="32"
  167. else
  168. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  169. echo "Please refer to the notes of build.sh$(tput sgr0)"
  170. exit 1
  171. fi
  172. else
  173. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  174. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  175. echo "Read the notes of build.sh$(tput sgr0)"
  176. exit 1
  177. fi
  178. sleep 2
  179. #### End check if OSTYPE is supported
  180. #### Prepare bash environment and check if wget, zip and other needed things are available
  181. # Check wget
  182. if ! type wget > /dev/null; then
  183. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  184. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  185. exit 2
  186. fi
  187. # Check for zip
  188. if ! type zip > /dev/null; then
  189. if [ $TARGET_OS == "windows" ]; then
  190. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  191. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  192. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  193. echo "Run git Bash under Administrator privilege and"
  194. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  195. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  196. exit 3
  197. elif [ $TARGET_OS == "linux" ]; then
  198. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  199. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  200. exit 3
  201. fi
  202. fi
  203. # Check python ... needed during language build
  204. if ! type python > /dev/null; then
  205. if [ $TARGET_OS == "windows" ]; then
  206. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  207. exit 4
  208. elif [ $TARGET_OS == "linux" ]; then
  209. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  210. echo "As Python 2.x will not be maintained from 2020 please,"
  211. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  212. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  213. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  214. exit 4
  215. fi
  216. fi
  217. #### End prepare bash / Linux environment
  218. #### Set build environment
  219. ARDUINO_ENV="1.8.5"
  220. BUILD_ENV="1.0.6"
  221. BOARD="prusa_einsy_rambo"
  222. BOARD_PACKAGE_NAME="PrusaResearch"
  223. BOARD_VERSION="1.0.3"
  224. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  225. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  226. BOARD_FILENAME="prusa3dboards"
  227. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  228. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  229. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  230. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  231. LIB="PrusaLibrary"
  232. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  233. # List few useful data
  234. echo
  235. echo "Script path :" $SCRIPT_PATH
  236. echo "OS :" $OS
  237. echo "OS type :" $TARGET_OS
  238. echo ""
  239. echo "Ardunio IDE :" $ARDUINO_ENV
  240. echo "Build env :" $BUILD_ENV
  241. echo "Board :" $BOARD
  242. echo "Package name:" $BOARD_PACKAGE_NAME
  243. echo "Board v. :" $BOARD_VERSION
  244. echo "Specific Lib:" $LIB
  245. echo ""
  246. #### Start prepare building environment
  247. #Check if build exists and creates it if not
  248. if [ ! -d "../PF-build-dl" ]; then
  249. mkdir ../PF-build-dl || exit 5
  250. fi
  251. cd ../PF-build-dl || exit 6
  252. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  253. # Check if PF-build-env-<version> exists and downloads + creates it if not
  254. # The build environment is based on the supported Arduino IDE portable version with some changes
  255. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  256. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  257. mkdir ../PF-build-env-$BUILD_ENV
  258. sleep 5
  259. fi
  260. # Download and extract supported Arduino IDE depending on OS
  261. # Windows
  262. if [ $TARGET_OS == "windows" ]; then
  263. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  264. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  265. sleep 2
  266. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  267. echo "$(tput sgr 0)"
  268. fi
  269. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  270. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  271. sleep 2
  272. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  273. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  274. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  275. echo "$(tput sgr0)"
  276. fi
  277. fi
  278. # Linux
  279. if [ $TARGET_OS == "linux" ]; then
  280. # 32 or 64 bit version
  281. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  282. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  283. sleep 2
  284. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  285. echo "$(tput sgr 0)"
  286. fi
  287. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  288. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  289. sleep 2
  290. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  291. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  292. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  293. echo "$(tput sgr0)"
  294. fi
  295. fi
  296. # Make Arduino IDE portable
  297. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  298. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  299. fi
  300. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  301. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  302. fi
  303. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  304. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  305. fi
  306. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  307. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  308. fi
  309. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  310. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  311. fi
  312. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  313. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  314. fi
  315. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  316. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  317. fi
  318. # Change Arduino IDE preferences
  319. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  320. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  321. sleep 2
  322. echo "update.check"
  323. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  324. echo "board"
  325. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  326. echo "editor.linenumbers"
  327. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  328. echo "boardsmanager.additional.urls"
  329. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  330. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  331. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  332. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  333. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  334. echo "$(tput sgr0)"
  335. fi
  336. # Download and extract Prusa Firmware related parts
  337. # Download and extract PrusaResearchRambo board
  338. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  339. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  340. sleep 2
  341. wget $BOARD_FILE_URL || exit 9
  342. fi
  343. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  344. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  345. sleep 2
  346. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  347. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  348. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  349. fi
  350. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  351. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  352. fi
  353. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  354. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  355. fi
  356. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  357. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  358. fi
  359. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  360. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  361. echo "$(tput sgr 0)"
  362. fi
  363. # Download and extract Prusa Firmware specific library files
  364. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  365. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  366. sleep 2
  367. wget $PF_BUILD_FILE_URL || exit 11
  368. echo "$(tput sgr 0)"
  369. fi
  370. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  371. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  372. sleep 2
  373. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  374. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  375. echo "$(tput sgr0)"
  376. fi
  377. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  378. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  379. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  380. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  381. sleep 2
  382. fi
  383. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  384. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  385. sleep 2
  386. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  387. sleep 2
  388. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  389. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  390. echo "$(tput sgr0)"
  391. fi
  392. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  393. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  394. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  395. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  396. sleep 2
  397. echo "$(tput sgr0)"
  398. exit 13
  399. fi
  400. #### End prepare building
  401. #### Start
  402. cd $SCRIPT_PATH
  403. # First argument defines which variant of the Prusa Firmware will be compiled
  404. if [ -z "$1" ] ; then
  405. # Select which variant of the Prusa Firmware will be compiled, like
  406. PS3="Select a variant: "
  407. while IFS= read -r -d $'\0' f; do
  408. options[i++]="$f"
  409. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  410. select opt in "${options[@]}" "All" "Quit"; do
  411. case $opt in
  412. *.h)
  413. VARIANT=$(basename "$opt" ".h")
  414. VARIANTS[i++]="$opt"
  415. break
  416. ;;
  417. "All")
  418. VARIANT="All"
  419. VARIANTS=${options[*]}
  420. break
  421. ;;
  422. "Quit")
  423. echo "You chose to stop"
  424. exit
  425. ;;
  426. *)
  427. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  428. ;;
  429. esac
  430. done
  431. else
  432. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  433. VARIANTS=$1
  434. else
  435. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  436. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  437. echo "$(tput sgr0)"
  438. exit 21
  439. fi
  440. fi
  441. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  442. #Check default language mode
  443. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  444. if [ -z "$2" ] ; then
  445. PS3="Select a language: "
  446. echo
  447. echo "Which lang-build do you want?"
  448. select yn in "Multi languages" "English only"; do
  449. case $yn in
  450. "Multi languages")
  451. LANGUAGES="ALL"
  452. break
  453. ;;
  454. "English only")
  455. LANGUAGES="EN_ONLY"
  456. break
  457. ;;
  458. *)
  459. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  460. ;;
  461. esac
  462. done
  463. else
  464. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  465. LANGUAGES=$2
  466. else
  467. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  468. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  469. exit 22
  470. fi
  471. fi
  472. #Check if DEV_STATUS is selected via argument 3
  473. if [ ! -z "$3" ] ; then
  474. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  475. DEV_STATUS_SELECTED=$3
  476. else
  477. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  478. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  479. exit 23
  480. fi
  481. fi
  482. #Set BUILD_ENV_PATH
  483. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  484. BUILD_ENV_PATH="$( pwd -P )"
  485. cd ../..
  486. #Checkif BUILD_PATH exists and if not creates it
  487. if [ ! -d "Prusa-Firmware-build" ]; then
  488. mkdir Prusa-Firmware-build || exit 25
  489. fi
  490. #Set the BUILD_PATH for Arduino IDE
  491. cd Prusa-Firmware-build || exit 26
  492. BUILD_PATH="$( pwd -P )"
  493. for v in ${VARIANTS[*]}
  494. do
  495. VARIANT=$(basename "$v" ".h")
  496. # Find firmware version in Configuration.h file and use it to generate the hex filename
  497. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  498. # Find build version in Configuration.h file and use it to generate the hex filename
  499. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  500. # Check if the motherboard is an EINSY and if so only one hex file will generated
  501. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  502. # Check development status
  503. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  504. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  505. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  506. DEV_STATUS="RC"
  507. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  508. DEV_STATUS="ALPHA"
  509. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  510. DEV_STATUS="BETA"
  511. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  512. DEV_STATUS="DEVEL"
  513. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  514. DEV_STATUS="DEBUG"
  515. else
  516. DEV_STATUS="UNKNOWN"
  517. echo
  518. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  519. PS3="Select YES only if source code is tested and trusted: "
  520. select yn in "Yes" "No"; do
  521. case $yn in
  522. Yes)
  523. DEV_STATUS="GOLD"
  524. DEV_STATUS_SELECTED="GOLD"
  525. break
  526. ;;
  527. No)
  528. DEV_STATUS="UNKNOWN"
  529. DEV_STATUS_SELECTED="UNKNOWN"
  530. break
  531. ;;
  532. *)
  533. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  534. ;;
  535. esac
  536. done
  537. fi
  538. else
  539. DEV_STATUS=$DEV_STATUS_SELECTED
  540. fi
  541. #Prepare hex files folders
  542. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  543. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  544. fi
  545. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  546. #Check if exactly the same hexfile already exists
  547. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  548. echo ""
  549. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  550. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  551. read -t 10 -p "Press Enter to continue..."
  552. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  553. echo ""
  554. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  555. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  556. read -t 10 -p "Press Enter to continue..."
  557. fi
  558. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  559. echo ""
  560. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  561. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  562. read -t 10 -p "Press Enter to continue..."
  563. fi
  564. #List some useful data
  565. echo "$(tput setaf 2)$(tput setab 7) "
  566. echo "Variant :" $VARIANT
  567. echo "Firmware :" $FW
  568. echo "Build # :" $BUILD
  569. echo "Dev Check :" $DEV_CHECK
  570. echo "DEV Status :" $DEV_STATUS
  571. echo "Motherboard:" $MOTHERBOARD
  572. echo "Languages :" $LANGUAGES
  573. echo "Hex-file Folder:" $OUTPUT_FOLDER
  574. echo "$(tput sgr0)"
  575. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  576. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  577. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  578. else
  579. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  580. read -t 10 -p "Press Enter to continue..."
  581. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  582. fi
  583. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  584. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  585. # set FW_REPOSITORY
  586. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  587. #Prepare english only or multilanguage version to be build
  588. if [ $LANGUAGES == "EN_ONLY" ]; then
  589. echo " "
  590. echo "English only language firmware will be built"
  591. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  592. echo " "
  593. else
  594. echo " "
  595. echo "Multi-language firmware will be built"
  596. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  597. echo " "
  598. fi
  599. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  600. # if [ $TARGET_OS == "windows" ]; then
  601. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  602. # fi
  603. #### End of Prepare building
  604. #### Start building
  605. export ARDUINO=$BUILD_ENV_PATH
  606. #echo $BUILD_ENV_PATH
  607. #export BUILDER=$ARDUINO/arduino-builder
  608. echo
  609. #read -t 5 -p "Press Enter..."
  610. echo
  611. echo "Start to build Prusa Firmware ..."
  612. echo "Using variant $VARIANT$(tput setaf 3)"
  613. sleep 2
  614. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  615. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  616. echo "$(tput sgr 0)"
  617. if [ $LANGUAGES == "ALL" ]; then
  618. echo "$(tput setaf 2)"
  619. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  620. echo "$(tput sgr 0)"
  621. sleep 2
  622. cd $SCRIPT_PATH/lang
  623. echo "$(tput setaf 3)"
  624. ./config.sh || exit 31
  625. echo "$(tput sgr 0)"
  626. # Check if previous languages and firmware build exist and if so clean them up
  627. if [ -f "lang_en.tmp" ]; then
  628. echo ""
  629. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  630. read -t 10 -p "Press Enter to continue..."
  631. echo "$(tput setaf 3)"
  632. ./lang-clean.sh
  633. echo "$(tput sgr 0)"
  634. fi
  635. if [ -f "progmem.out" ]; then
  636. echo ""
  637. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  638. read -t 10 -p "Press Enter to continue..."
  639. echo "$(tput setaf 3)"
  640. ./fw-clean.sh
  641. echo "$(tput sgr 0)"
  642. fi
  643. # build languages
  644. echo "$(tput setaf 3)"
  645. ./lang-build.sh || exit 32
  646. # Combine compiled firmware with languages
  647. ./fw-build.sh || exit 33
  648. cp not_tran.txt not_tran_$VARIANT.txt
  649. cp not_used.txt not_used_$VARIANT.txt
  650. echo "$(tput sgr 0)"
  651. # Check if the motherboard is an EINSY and if so only one hex file will generated
  652. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  653. # If the motherboard is an EINSY just copy one hexfile
  654. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  655. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  656. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  657. else
  658. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  659. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  660. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  661. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  662. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  663. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  664. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  665. if [ $TARGET_OS == "windows" ]; then
  666. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  667. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  668. elif [ $TARGET_OS == "linux" ]; then
  669. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  670. fi
  671. fi
  672. # Cleanup after build
  673. echo "$(tput setaf 3)"
  674. ./fw-clean.sh || exit 34
  675. ./lang-clean.sh || exit 35
  676. echo "$(tput sgr 0)"
  677. else
  678. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  679. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  680. fi
  681. # Cleanup Firmware
  682. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  683. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  684. then
  685. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  686. fi
  687. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  688. then
  689. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  690. fi
  691. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  692. then
  693. rm $SCRIPT_PATH/lang/not_tran.txt
  694. fi
  695. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  696. then
  697. rm $SCRIPT_PATH/lang/not_used.txt
  698. fi
  699. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  700. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  701. echo $MULTI_LANGUAGE_CHECK
  702. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  703. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  704. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  705. sleep 5
  706. done
  707. # Switch to hex path and list build files
  708. cd $SCRIPT_PATH
  709. cd ..
  710. echo "$(tput setaf 2) "
  711. echo " "
  712. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  713. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  714. #### End building